function chapter3_example_7_2_sanbianliang_RK
clear all
close all
clc
%ȽEulerĽRK㷨-----

a=1;x1 = 6; N = 600;
h = (x1-a)/N;
x = a:h:x1;

y10=8;   %ʼ
y20=7;    
y30=4;
%-----------ȷ--------
y=@(x)(5*x)/2+(6*exp(x))/exp(1)-x.^2/2-x.^3/6 +1/6;
%----------Euler㷨------------------------------
yy1=zeros(1,N+1);
yy2=zeros(1,N+1);
yy3=zeros(1,N+1);
yy1(1)=y10;
yy2(1)=y20;
yy3(1)=y30;
for n=1:N %Eulerʽ
    yy1(n+1)=yy1(n)+h*yy2(n);
    yy2(n+1)=yy2(n)+h*yy3(n);
    yy3(n+1)=yy3(n)+h*(yy3(n)+x(n));
end

%----------Euler㷨һֳдʽ------------------------------
f=@(x,y)[y(2), y(3), y(3)+x]; %  fx(2)=p,x(1)=y
z0 = [y10,y20,y30];      %ʼ
z_euler=zeros(N+1,3);
z_euler(1,:)=z0;
for n=1:N %Eulerʽ,˳ҲΪͨóڳ΢ַ
    z_euler(n+1,:)=z_euler(n,:)+h*f(x(n),z_euler(n,:));
end
y_euler = z_euler(:,1)'; 
figure;plot(x,y_euler-yy1,'r')
title('ȽEulerֳд')

%--------------ĽRK㷨------------------------
f=@(x,y)[y(2), y(3), y(3)+x]; %  fx(2)=p,x(1)=y
z0 = [y10,y20,y30];      %ʼ

z = myrungekutta(f, x, z0);
y_4rk = z(:,1)'; 

figure;plot(x,yy1,'r',x,y_4rk,'b',x,y(x),'g')
title('΢̵ֵַ')
legend('Euler','ĽR-K','')
figure;plot(x,y(x)-y_4rk,'b')
title('΢̵ֵַ')
legend('Euler','ĽR-K')

function z = myrungekutta(f, t, z0)
n = length(t);
h = t(2)-t(1);
%z=zeros(n,3);
z(1,:)=z0;
for i = 1:n-1
    k1=f(t(i), z(i,:));
    k2=f(t(i)+0.5*h, z(i,:) + h*k1/2);
    k3=f(t(i)+0.5*h, z(i,:) + h*k2/2);
    k4=f(t(i)+h, z(i,:) + h*k3);
    z(i+1,:)=z(i,:) + h*(k1 + 2*k2 + 2*k3 + k4)/6;
end

