function chapter3_example_7_3_four_x_RK
clear all
close all
clc
%ĽRK㷨-----

a=0;x1 = 100; N = 1000;
h = (x1-a)/N;
t = a:h:x1;

y10=1;   %ʼ
y20=0;    
v10=2;
v20=5;
%--------------ĽRK㷨,д------------------------
f=@(t,y)[y(3), y(4), -y(3)-0.2*(y(3)-y(4))+sin(y(1))+sin(t),-y(4)-0.2*(y(4)-y(3))+cos(y(2))+sin(t)]; %  fx(2)=p,x(1)=y
z0 = [y10,y20,v10,v20];      %ʼ

z = myrungekutta(f, t, z0);
yyy1 = z(:,1)'; %°汾matlabԲתãͿԻͼ
yyy2 = z(:,2)'; 
yyy3 = z(:,3)'; 
yyy4 = z(:,4)'; 

figure;plot(t,yyy1,'b',t,yyy2,'r',t,yyy3,'k',t,yyy4,'g')
title('Ľ׳΢̵ֵַ')
legend('Y1','Y2','dY1/dt','dY2/dt')


function z = myrungekutta(f, t, z0)
n = length(t);
h = t(2)-t(1);
%z=zeros(n,4);
z(1,:)=z0;
for i = 1:n-1
    k1=f(t(i), z(i,:));
    k2=f(t(i)+0.5*h, z(i,:) + h*k1/2);
    k3=f(t(i)+0.5*h, z(i,:) + h*k2/2);
    k4=f(t(i)+h, z(i,:) + h*k3);
    z(i+1,:)=z(i,:) + h*(k1 + 2*k2 + 2*k3 + k4)/6;
end

