function dirven_pendulum
clear all
close all
clc

q=0.5; 
b=0.9; 
omega0=2/3; %ǿƵ
theta0=pi*40/180; %ʼǶȣԻΪλ

time = 100; N = 160000;
h = time/N;
t = 0:h:time;

f=@(t,x)[x(2), -q*x(2)-sin(x(1))+b*cos(omega0*t)];
%
z = [theta0, 0]; %ʼעǶȲûȵλٶΪ0

z = myrungekutta(f, t, z);
theta = z(:,1);
omega = z(:,2); 

subplot(3,1,1) 
plot(t, theta,'b')%,t,omega,'r') 
title('ڵĽǶʱı仯ϵ')
subplot(3,1,2) 
plot(t, omega,'b')%,t,omega,'r') 
title('ڵĽٶʱı仯ϵ')
%title('ڵĽǶٶʱı仯ϵ')
%legend('Ƕ','ٶ')
subplot(3,1,3)
%plot(theta, omega)
plot(theta(N/2:N), omega(N/2: N))
title('Ƕ-ٶͼ')


function z = myrungekutta(f, t, z)
n = length(t);
h = t(2)-t(1);
for i = 1:n-1
    k1=f(t(i), z(i,:));
    k2=f(t(i)+0.5*h, z(i,:) + h*k1/2);
    k3=f(t(i)+0.5*h, z(i,:) + h*k2/2);
    k4=f(t(i)+h, z(i,:) + h*k3);
    z(i+1,:)=z(i,:) + h*(k1 + 2*k2 + 2*k3 + k4)/6;
end

  
