function chapter3_example_7_2_sanbianliang_RK
clear all
close all
clc
%ȽEulerĽRK㷨-----

x1 = 6; N = 300;
h = (x1-1)/N;
x = 1:h:x1;

y10=8;   %ʼ
y20=7;    
y30=4;
y=@(x)(5*x)/2+(6*exp(x))/exp(1)-x.^2/2-x.^3/6 +1/6;%
%----------Euler㷨------------------------------
yy1=zeros(1,N+1);
yy2=zeros(1,N+1);
yy3=zeros(1,N+1);
yy1(1)=y10;
yy2(1)=y20;
yy3(1)=y30;
for n=1:N %Eulerʽ
    yy1(n+1)=yy1(n)+h*yy2(n);
    yy2(n+1)=yy2(n)+h*yy3(n);
    yy3(n+1)=yy3(n)+h*(yy3(n)+x(n));
end

%--------------ĽRK㷨------------------------
yyy1=zeros(1,N+1);
yyy2=zeros(1,N+1);
yyy3=zeros(1,N+1);
yyy1(1)=y10;
yyy2(1)=y20;
yyy3(1)=y30;

f=@(x,y1,y2,y3)[y2, y3, y3+x]; %  f
z0 = [y10,y20,y30];      %ʼ
z = myrungekutta(f, x, z0);
yyy1 = z(:,1); 

plot(x,yy1,'r',x,yyy1,'b',x,y(x),'k')
title('΢̵ֵַ')
legend('Euler','ĽR-K','ȷ')
figure;plot(x,y(x)-yy1,'r',x,y(x)-yyy1','b')
title('΢̵ֵַ')
legend('Euler','ĽR-K')

function  z= myrungekutta(f, t, z0)
n = length(t);
h = t(2)-t(1);
z(1,:)=z0;
for i = 1:n-1
    k1=f(t(i), z(i,1),z(i,2),z(i,3));
    k2=f(t(i)+0.5*h, z(i,1) + h*k1(1)/2,z(i,2) + h*k1(2)/2,z(i,3) + h*k1(3)/2);
    k3=f(t(i)+0.5*h, z(i,1) + h*k2(1)/2,z(i,2) + h*k2(2)/2,z(i,3) + h*k2(3)/2);
    k4=f(t(i)+h, z(i,1) + h*k3(1),z(i,2) + h*k3(2),z(i,3) + h*k3(3));
    z(i+1,:)=z(i,:) + h*(k1 + 2*k2 + 2*k3 + k4)/6;
end

