function two_variables_RK
clear all
close all
clc
format long
%ȽEulerĽRK㷨-----

time = 10; N = 40000;
h = time/N;
t = 0:h:time;

y0=5;   %ʼλ,
p0=0;   %ʼ,

%--------------------------------------
m=1;    %гӵΪ1
k=4*pi^2; %ɵľϵ
A=sqrt(y0^2+p0^2/(m*k)); %гӵ
pha=acos(y0/A);          %гӵĳʼλx0p0ͬţphaΪphaΪ
y_e=A*cos(sqrt(k/m)*t+pha); %гӵľȷ
p_e=-m*A*sqrt(k/m)*sin(sqrt(k/m)*t+pha); %ľȷ
E_e=p_e.^2/(2*m)+0.5*k*y_e.^2 %ľȷֵ
%E_e(1)

%----------Euler㷨------------------------------
yyy=zeros(1,N+1);
ppp=zeros(1,N+1);
yyy(1)=y0;
ppp(1)=p0;
for n=1:N %Eulerʽ
    yyy(n+1)=yyy(n)+h*ppp(n);
    ppp(n+1)=ppp(n)-h*4*pi^2*yyy(n);
end
E_euler=ppp.^2/(2*m)+0.5*k*yyy.^2; %ֵ
figure,subplot(2,2,1),plot(t,yyy,'r',t,y_e,'b')
title('гӵλãEuler㷨뾫ȷȽϣ')
legend('Euler㷨','ȷ')
subplot(2,2,2),plot(t,ppp,'r',t,p_e,'b')
title('гӵĶEuler㷨뾫ȷȽϣ')
legend('Euler㷨','ȷ')
subplot(2,2,3),plot(yyy,ppp,'r',y_e,p_e,'b')
title('гӵͼEuler㷨뾫ȷȽϣ')
legend('Euler㷨','ȷ')
subplot(2,2,4),plot(t,E_euler-E_e,'r',t,E_e,'b')
title('')

%----------Euler㷨һֳдʽ------------------------------
f=@(t,x)[x(2), -4*pi^2*x(1)]; %  fдʽ
z0 = [y0, p0];      %ʼy0=5,p0=0
z_euler=zeros(N+1,2);
z_euler(1,:)=z0;
for n=1:N %Eulerʽ,˳ҲΪͨóڳ΢ַ
    z_euler(n+1,:)=z_euler(n,:)+h*f(t(n),z_euler(n,:));
end
y_euler = z_euler(:,1)'; 
p_euler = z_euler(:,2)'; 
E_euler_1=p_euler.^2/(2*m)+0.5*k*y_euler.^2; %ֵ
figure,subplot(2,2,1),plot(t,y_euler,'r',t,y_e,'b')
title('гӵλãд2')
legend('Euler㷨','ȷ')
subplot(2,2,2),plot(t,p_euler,'r',t,p_e,'b')
title('гӵĶд2')
legend('Euler㷨','ȷ')
subplot(2,2,3),plot(y_euler,p_euler,'r',y_e,p_e,'b')
title('гӵͼд2')
legend('Euler㷨','ȷ')
subplot(2,2,4),plot(t,E_euler_1-E_e,'r')
title('')

%--------------ĽRK㷨------------------------
yy=zeros(1,N+1);
pp=zeros(1,N+1);
yy(1)=y0;
pp(1)=p0;
%f=@(t,x)[x(2), -4*pi^2*x(1)]; %  fx(2)=p,x(1)=y
%z0 = [y0, p0];      %ʼy0=5,p0=0
%EulerдѾ

z = myrungekutta(f, t, z0);
yy = z(:,1)'; 
pp = z(:,2)'; 
E_rk=pp.^2/(2*m)+0.5*k*yy.^2; %ֵ

figure,subplot(2,2,1),plot(t,yy,'r',t,y_e,'b')
title('гӵλãĽRK㷨뾫ȷȽϣ')
legend('ĽRK㷨','ȷ')
subplot(2,2,2),plot(t,pp,'r',t,p_e,'b')
title('гӵĶĽRK㷨뾫ȷȽϣ')
legend('ĽRK㷨','ȷ')
subplot(2,2,3),plot(yy,pp,'r',y_e,p_e,'b')
title('гӵͼĽRK㷨뾫ȷȽϣ')
legend('ĽRK㷨','ȷ')
subplot(2,2,4),plot(t,E_rk-E_e,'r')
title('')
%ӽԿ4RK㷨Ա֤гӵغ㣬Euler
%figure;plot(t,yy-y_e,'r')
%legend('ĽRK㷨')

function z = myrungekutta(f, t, z0)
n = length(t);
h = t(2)-t(1);
z=zeros(n,2); 
%һn2е飬2Ϊδ֪ĸҲз̵ĸ
z(1,:)=z0;
for i = 1:n-1
    k1=f(t(i), z(i,:));
    k2=f(t(i)+0.5*h, z(i,:) + h*k1/2);
    k3=f(t(i)+0.5*h, z(i,:) + h*k2/2);
    k4=f(t(i)+h, z(i,:) + h*k3);
    z(i+1,:)=z(i,:) + h*(k1 + 2*k2 + 2*k3 + k4)/6;
end


















