%ĽRK㷨һάгӵ˶
function two_variables_RK
clear all
close all
clc

time = 5; N = 4000;
h = time/N;
t = 0:h:time;

y0=5;   %ʼλ,
p0=20;   %ʼ,

%--------------RK㷨------------------------
yy=zeros(1,N+1);
pp=zeros(1,N+1);
%yy(1)=y0;
%pp(1)=p0;

f=@(t,x)[x(2), -4*pi^2*x(1)]; %  fx(2)=p,x(1)=y
z0 = [y0, p0]; 
z = myrungekutta(f, t, z0);
yy = z(:,1); 
pp = z(:,2); 

subplot(2,1,1),plot(t,yy,'r',t,pp,'b')
title('λúͶʱݻϵ')
legend('λ','')
subplot(2,1,2),plot(yy,pp,'r')
title('λ-ͼ')


function z = myrungekutta(f, t, z0)
n = length(t);
h = t(2)-t(1);
z=zeros(n,2);
z(1,:)=z0;
for i = 1:n-1
    k1 = h*f(t(i), z(i,:));
    k2=h*f(t(i)+0.5*h, z(i,:) + k1/2);
    k3=h*f(t(i)+0.5*h, z(i,:) + k2/2);
    k4=h*f(t(i)+h, z(i,:) + k3);
    z(i+1,:)=z(i,:) + (k1 + 2*k2 + 2*k3 + k4)/6;
end

